package cz.czu.bcp.trosa.bachelorsPrototype.controller;

import cz.czu.bcp.trosa.bachelorsPrototype.dto.CreateClientDto;
import cz.czu.bcp.trosa.bachelorsPrototype.dto.CreateContractDto;
import cz.czu.bcp.trosa.bachelorsPrototype.dto.UpdateClientDto;
import cz.czu.bcp.trosa.bachelorsPrototype.dto.UpdateContractDto;
import cz.czu.bcp.trosa.bachelorsPrototype.service.ContractService;
import org.hibernate.sql.Update;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.security.core.Authentication;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/contract")

public class ContractController {
    private final ContractService contractService;

    @Autowired
    public ContractController(ContractService contractService) {
        this.contractService = contractService;
    }

    @PostMapping(consumes = MediaType.APPLICATION_JSON_VALUE)
    @ResponseStatus(HttpStatus.CREATED)
    @PreAuthorize("isAuthenticated()")
    public void create(@RequestBody CreateContractDto body, Authentication auth) {
        contractService.persist(body, auth);

    }
    @PutMapping(consumes = MediaType.APPLICATION_JSON_VALUE)
    @ResponseStatus(HttpStatus.CREATED)
    @PreAuthorize("isAuthenticated()")
    public void update(@RequestBody UpdateContractDto body, Long id){
       contractService.update(body, id);
    }


}
