package cz.czu.bcp.trosa.bachelorsPrototype.controller.utils;

import org.springframework.http.HttpHeaders;
import org.springframework.web.servlet.support.ServletUriComponentsBuilder;

import java.net.URI;


public class HttpHeadersFactory {

    public static HttpHeaders createLocationHeaderFromCurrentUri(String path, Object... uriVariableValues) {
        assert path != null;

        final URI location = ServletUriComponentsBuilder.fromCurrentRequestUri().path(path).buildAndExpand(
                uriVariableValues).toUri();
        final HttpHeaders headers = new HttpHeaders();
        headers.set(HttpHeaders.LOCATION, location.toASCIIString());
        return headers;
    }

    public static HttpHeaders createLocationHeaderInsideApplication(String path, Object... uriVariableValues){
        assert path != null;

        final URI location = ServletUriComponentsBuilder.fromCurrentContextPath().path(path).buildAndExpand(
                uriVariableValues).toUri();
        final HttpHeaders headers = new HttpHeaders();
        headers.set(HttpHeaders.LOCATION,location.toASCIIString());
        return headers;
    }
}