package cz.czu.bcp.trosa.bachelorsPrototype.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import cz.czu.bcp.trosa.bachelorsPrototype.model.Client;
import cz.czu.bcp.trosa.bachelorsPrototype.model.User;
import org.springframework.beans.factory.annotation.Required;

import java.io.Serializable;
import javax.validation.constraints.*;

public class CreateClientDto implements Serializable {
    @NotEmpty
    public long phoneNumber;

    @NotEmpty
    @Email
    public String email;

    @NotEmpty
    public long personalNumber;

    @NotEmpty
    public String firstname;

    @NotEmpty
    public String surname;

    @NotEmpty
    public int zipCode;

    @NotEmpty
    public String countryCode;

    @NotEmpty
    public String street;

    @NotEmpty
    public String houseNumber;

    @NotEmpty
    public String city;

    public Client getClient() {
        var client = new Client();
        client.setEmail(email);
        client.setCity(city);
        client.setCountryCode(countryCode);
        client.setFirstname(firstname);
        client.setHouseNumber(houseNumber);
        client.setPersonalNumber(personalNumber);
        client.setPhoneNumber(phoneNumber);
        client.setZipCode(zipCode);
        client.setSurname(surname);
        client.setStreet(street);
        return client;
    }
}
