package cz.czu.bcp.trosa.bachelorsPrototype.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import cz.czu.bcp.trosa.bachelorsPrototype.model.Client;
import cz.czu.bcp.trosa.bachelorsPrototype.model.Contract;
import cz.czu.bcp.trosa.bachelorsPrototype.model.User;

import javax.persistence.ManyToOne;
import javax.validation.constraints.Min;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.util.Objects;


public class CreateContractDto implements Serializable {
    @JsonFormat(pattern = "yyyy-MM-dd")
    @NotNull
    public LocalDate startDate;
    @JsonFormat(pattern = "yyyy-MM-dd")
    @NotNull
    public LocalDate dueDate;
    @Min(1)
    @NotNull
    public BigDecimal providedAmount;
    @Min(1)
    public BigDecimal remainingAmount;
    @Min(1)
    public BigDecimal overdueAmount;
    @NotNull
    public Long clientId;

    public Contract getContract() {
        var contract = new Contract();
        contract.setStartDate(startDate);
        contract.setDueDate(dueDate);
        contract.setProvidedAmount(providedAmount);
        if (remainingAmount == null)
            contract.setRemainingAmount(providedAmount);
        else
            contract.setRemainingAmount(remainingAmount);
        contract.setOverdueAmount(Objects.requireNonNullElseGet(overdueAmount, () -> new BigDecimal(0)));
        return contract;
    }
}
