package cz.czu.bcp.trosa.bachelorsPrototype.model;

import com.fasterxml.jackson.annotation.JsonIgnore;

import javax.persistence.*;
import java.util.ArrayList;
import java.util.List;

@Entity
@Table(name = "client")
public class Client extends AbstractModel {
    @Basic(optional = false)
    private long phoneNumber;

    @Basic(optional = false)
    private String email;

    @Basic(optional = false)
    @Column(unique = true)
    private long personalNumber;

    @Basic(optional = false)
    private String firstname;

    @Basic(optional = false)
    private String surname;

    @Basic(optional = false)
    @Column(length = 5)
    private int zipCode;

    @Basic(optional = false)
    @Column(length = 2)
    private String countryCode;

    @Basic(optional = false)
    private String street;

    @Basic(optional = false)
    private String houseNumber;

    @Basic(optional = false)
    private String city;

    @OneToMany(mappedBy = "client")
    @JsonIgnore
    private List<Contract> contracts;

    public long getPhoneNumber() {
        return phoneNumber;
    }

    public void setPhoneNumber(long phoneNumber) {
        this.phoneNumber = phoneNumber;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public long getPersonalNumber() {
        return personalNumber;
    }

    public void setPersonalNumber(long personalNumber) {
        this.personalNumber = personalNumber;
    }

    public String getFirstname() {
        return firstname;
    }

    public void setFirstname(String firstname) {
        this.firstname = firstname;
    }

    public String getSurname() {
        return surname;
    }

    public void setSurname(String surname) {
        this.surname = surname;
    }

    public int getZipCode() {
        return zipCode;
    }

    public void setZipCode(int zipCode) {
        this.zipCode = zipCode;
    }

    public String getCountryCode() {
        return countryCode;
    }

    public void setCountryCode(String countryCode) {
        this.countryCode = countryCode;
    }

    public String getStreet() {
        return street;
    }

    public void setStreet(String street) {
        this.street = street;
    }

    public String getHouseNumber() {
        return houseNumber;
    }

    public void setHouseNumber(String houseNumber) {
        this.houseNumber = houseNumber;
    }

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public List<Contract> getContracts() {
        return contracts;
    }

    public void addContract(Contract contract) {
        if (this.contracts == null){
            this.contracts = new ArrayList<>();
        }
        this.contracts.add(contract);
    }
}
