package cz.czu.bcp.trosa.bachelorsPrototype.model;

import com.fasterxml.jackson.annotation.JsonFormat;

import javax.persistence.*;
import java.math.BigDecimal;
import java.time.LocalDate;

@Entity
@Table(name = "contract")
public class Contract extends AbstractModel {
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Basic()
    private LocalDate startDate;
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Basic()
    private LocalDate dueDate;
    @Column(precision = 10, scale = 2)
    private BigDecimal providedAmount;
    @Column(precision = 10, scale = 2)
    private BigDecimal remainingAmount;
    @Column(precision = 10, scale = 2)
    private BigDecimal overdueAmount;
    @ManyToOne(optional = false)
    private User provider;
    @ManyToOne(optional = false)
    private Client client;
    @Column(nullable = false)
    private Boolean active = true;

    public LocalDate getStartDate() {
        return startDate;
    }

    public void setStartDate(LocalDate startDate) {
        this.startDate = startDate;
    }

    public LocalDate getDueDate() {
        return dueDate;
    }

    public void setDueDate(LocalDate dueDate) {
        this.dueDate = dueDate;
    }

    public BigDecimal getProvidedAmount() {
        return providedAmount;
    }

    public void setProvidedAmount(BigDecimal providedAmount) {
        this.providedAmount = providedAmount;
    }

    public BigDecimal getRemainingAmount() {
        return remainingAmount;
    }

    public void setRemainingAmount(BigDecimal remainingAmount) {
        this.remainingAmount = remainingAmount;
    }

    public BigDecimal getOverdueAmount() {
        return overdueAmount;
    }

    public void setOverdueAmount(BigDecimal overdueAmount) {
        this.overdueAmount = overdueAmount;
    }

    public User getProvider() {
        return provider;
    }

    public void setProvider(User provider) {
        this.provider = provider;
    }

    public Client getClient() {
        return client;
    }

    public void setClient(Client client) {
        this.client = client;
    }
}
