package cz.czu.bcp.trosa.bachelorsPrototype.model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import org.springframework.security.core.authority.SimpleGrantedAuthority;

import javax.persistence.*;
import javax.swing.*;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.List;

@Entity
@Table(name = "app_user")
public class User extends AbstractModel {
   @JsonIgnore
   private String password;
   @Basic(optional=false)
   @Column(nullable = true,unique = true)
   private String email;
   @Basic(optional=false)
   @Column(nullable = true,unique = true)
   private String username;
   private int ICO;
   @OneToMany(mappedBy = "provider")
   @JsonIgnore
   private List<Contract> contracts;

   @Override
   public String toString() {
      return "User{" +
              "password='" + password + '\'' +
              ", email='" + email + '\'' +
              ", username='" + username + '\'' +
              ", ICO=" + ICO +
              ", contracts=" + contracts +
              '}';
   }

   public String getPassword() {
      return password;
   }

   public void setPassword(String password) {
      this.password = password;
   }

   public String getEmail() {
      return email;
   }

   public void setEmail(String email) {
      this.email = email;
   }

   public String getUsername() {
      return username;
   }

   public void setUsername(String username) {
      this.username = username;
   }

   public int getICO() {
      return ICO;
   }

   public void setICO(int ICO) {
      this.ICO = ICO;
   }

   public List<Contract> getContracts() {
      return contracts;
   }

   public void addContract(Contract contract) {
     if (this.contracts == null){
        this.contracts = new ArrayList<>();
     }
      this.contracts.add(contract);
   }
   public ArrayList<SimpleGrantedAuthority> getAuthorities(){
      var temp = new ArrayList<SimpleGrantedAuthority>();
      temp.add(new SimpleGrantedAuthority("User"));
      return temp;
   }
}

